/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     GROUPS = 258,
     SEMICOLON = 259,
     LBRACKET = 260,
     RBRACKET = 261,
     EQUAL = 262,
     AT = 263,
     STAR = 264,
     COMMA = 265,
     NEWLINE = 266,
     TRAC = 267,
     ID = 268,
     DIR = 269
   };
#endif
#define GROUPS 258
#define SEMICOLON 259
#define LBRACKET 260
#define RBRACKET 261
#define EQUAL 262
#define AT 263
#define STAR 264
#define COMMA 265
#define NEWLINE 266
#define TRAC 267
#define ID 268
#define DIR 269




/* Copy the first part of user declarations.  */
#line 1 "parser.y"


  /*! \file parser.c
    \brief svnaccess file parser.
  */

#include "svnauthcheck.h"
#include <stdio.h>
    
  char                            location[MAX_FILE_NAME_LENGTH];
  extern FILE                   * htaccess;
  extern char                     subtree[MAX_USER_SIZE];
  extern char                     user[MAX_USER_SIZE];
  extern char                   * yytext;
  extern int                      apache_flag;
#ifdef DEBUG
  extern int                      debug_flag;
#endif  
  extern int                      subtree_flag;
  extern int                      yylineno;
  extern char                     filename[MAX_FILE_NAME_LENGTH];
  extern struct user_type       * additional_readers;
  extern struct user_type       * anybody;
  extern struct user_type       * revoked_readers;
  extern struct user_type       * first_admin;
  int                             star;
  struct node                   * dir_node;
  struct user_type              * cur;
  struct user_type              * tmp_user;

  extern struct symbol          * table;

#ifdef HAVE_SQLITE_H
  extern struct trac_permission * trac;
#endif

  struct user_type        * group;


  
  int  yylex        (void);
  void yyerror      (char const * message);
  void init_readers ();

  
  /* initialize the reader lists */
  void init_readers() {
    additional_readers = NULL;
    revoked_readers    = NULL;
  }
 
  

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 56 "parser.y"
typedef union YYSTYPE {
  struct user_type *list;
  char *string;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 162 "parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 174 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   60

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  15
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  14
/* YYNRULES -- Number of rules. */
#define YYNRULES  29
/* YYNRULES -- Number of states. */
#define YYNSTATES  58

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   269

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    13,    18,    24,    26,
      30,    32,    35,    37,    40,    44,    45,    52,    53,    62,
      67,    74,    76,    79,    84,    88,    93,    97,    99,   102
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      17,     0,    -1,    11,    -1,    11,    16,    -1,    21,    -1,
      21,    27,    -1,    13,     7,    19,    16,    -1,    18,    13,
       7,    19,    16,    -1,    20,    -1,    19,    10,    20,    -1,
      13,    -1,     8,    13,    -1,    22,    -1,    21,    22,    -1,
       3,    16,    18,    -1,    -1,     5,    14,     6,    16,    23,
      25,    -1,    -1,     5,    13,     4,    14,     6,    16,    24,
      25,    -1,     5,    14,     6,    16,    -1,     5,    13,     4,
      14,     6,    16,    -1,    26,    -1,    26,    25,    -1,    20,
       7,    13,    16,    -1,    20,     7,    16,    -1,     9,     7,
      13,    16,    -1,     9,     7,    16,    -1,    28,    -1,    27,
      28,    -1,    12,    13,     7,    13,    16,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   100,   100,   101,   108,   111,   119,   130,   146,   156,
     173,   180,   222,   228,   245,   247,   247,   302,   302,   355,
     362,   372,   381,   394,   420,   436,   458,   477,   478,   481
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "GROUPS", "SEMICOLON", "LBRACKET",
  "RBRACKET", "EQUAL", "AT", "STAR", "COMMA", "NEWLINE", "TRAC", "ID",
  "DIR", "$accept", "newlines", "file", "group_def", "id_list", "id",
  "dir_rule_list", "dir_rule", "@1", "@2", "rule_list", "rule",
  "trac_permissions_list", "trac_permissions", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    15,    16,    16,    17,    17,    18,    18,    19,    19,
      20,    20,    21,    21,    22,    23,    22,    24,    22,    22,
      22,    25,    25,    26,    26,    26,    26,    27,    27,    28
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     2,     4,     5,     1,     3,
       1,     2,     1,     2,     3,     0,     6,     0,     8,     4,
       6,     1,     2,     4,     3,     4,     3,     1,     2,     5
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     4,    12,     2,     0,     0,     0,
       1,     0,    13,     5,    27,     3,     0,    14,     0,     0,
       0,    28,     0,     0,     0,    19,     0,     0,    10,     0,
       8,     0,     0,     0,     0,    11,     0,     6,     0,    20,
       0,     0,    16,    21,    29,     9,     7,     0,     0,     0,
      22,    18,     0,    26,     0,    24,    25,    23
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     7,     3,    17,    29,    41,     4,     5,    33,    47,
      42,    43,    13,    14
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -39
static const yysigned_char yypact[] =
{
       9,     7,    -7,    22,    -1,   -39,     7,    24,    34,    33,
     -39,    27,   -39,    29,   -39,   -39,    37,    32,    35,     7,
      40,   -39,    -5,    43,    45,     8,    39,    41,   -39,    25,
     -39,    -5,     7,    11,     7,   -39,    -5,   -39,    25,    21,
      46,    48,   -39,    11,   -39,   -39,   -39,    11,    14,    20,
     -39,   -39,     7,   -39,     7,   -39,   -39,   -39
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -39,    -6,   -39,   -39,    26,   -21,   -39,    52,   -39,   -39,
     -38,   -39,   -39,    47
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -18
static const yysigned_char yytable[] =
{
      15,    30,     1,    27,     2,    50,     8,     9,    28,    51,
      30,    11,     1,    25,     2,    45,   -15,   -15,     6,    27,
      40,   -15,    10,    37,    28,     6,    39,    52,    44,   -17,
     -17,     6,    46,    54,   -17,    36,     6,    16,    18,    19,
      20,    11,    53,    55,    22,    23,    56,    26,    57,    24,
      31,    32,    34,    48,    35,    49,    12,    38,     0,     0,
      21
};

static const yysigned_char yycheck[] =
{
       6,    22,     3,     8,     5,    43,    13,    14,    13,    47,
      31,    12,     3,    19,     5,    36,     8,     9,    11,     8,
       9,    13,     0,    29,    13,    11,    32,    13,    34,     8,
       9,    11,    38,    13,    13,    10,    11,    13,     4,     6,
      13,    12,    48,    49,     7,    13,    52,     7,    54,    14,
       7,     6,    13,     7,    13,     7,     4,    31,    -1,    -1,
      13
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     5,    17,    21,    22,    11,    16,    13,    14,
       0,    12,    22,    27,    28,    16,    13,    18,     4,     6,
      13,    28,     7,    13,    14,    16,     7,     8,    13,    19,
      20,     7,     6,    23,    13,    13,    10,    16,    19,    16,
       9,    20,    25,    26,    16,    20,    16,    24,     7,     7,
      25,    25,    13,    16,    13,    16,    16,    16
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 108 "parser.y"
    {
  first_admin = yyvsp[0].list;
}
    break;

  case 5:
#line 111 "parser.y"
    {
  first_admin = yyvsp[-1].list;
}
    break;

  case 6:
#line 119 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) {
    printf("[debug-grammar] %i: group_def: ID(%s) = id_list(", yylineno, yyvsp[-3].string);
    print_list(yyvsp[-1].list);
    printf(")\n");
  }
#endif
  create_group(yyvsp[-3].string, yyvsp[-1].list);
  if (yyvsp[-3].string) { free(yyvsp[-3].string); }
}
    break;

  case 7:
#line 130 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) {
    printf("[debug-grammar] %i: group_def: ID(%s) = id_list(", yylineno, yyvsp[-3].string);
    print_list(yyvsp[-1].list);
    printf(")\n");
  }
#endif
  create_group(yyvsp[-3].string, yyvsp[-1].list);
  if (yyvsp[-3].string) { free(yyvsp[-3].string); }
}
    break;

  case 8:
#line 146 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) {
    printf("[debug-grammar] %i: id_list : id(", yylineno);
    print_list(yyvsp[0].list);
    printf(")\n");
  }
#endif
  yyval.list = yyvsp[0].list;
}
    break;

  case 9:
#line 156 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) {
    printf("[debug-grammar] %i: id_list : id_list(", yylineno);
    print_list(yyvsp[-2].list);
    printf(" COMMA id(");
    print_list(yyvsp[0].list);
    printf(")\n");
  }
#endif
  yyval.list = append(yyvsp[-2].list, yyvsp[0].list);
}
    break;

  case 10:
#line 173 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: id : ID(%s)\n", yylineno, yyvsp[0].string); }
#endif
  yyval.list = new_user(yyvsp[0].string);
  if (yyvsp[0].string) { free(yyvsp[0].string); }
}
    break;

  case 11:
#line 180 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: id := @ %s\n", yylineno, yyvsp[0].string); }
#endif
  
  /* we can check groups only for complete files */
  if (!subtree_flag) {
    
    /* get the group from the symbol table */
    group = get_group(yyvsp[0].string);
    
    if (group == NULL) {
#ifdef HAVE_STRNLEN      
      char * msg = malloc(strlen("unknown group ") +
                          strnlen(yyvsp[0].string, MAX_USER_SIZE));
#else
      char * msg = malloc(strlen("unknown group ") +
                          strlen(yyvsp[0].string));
#endif      
      strcpy(msg, "unknown group ");
      strcat(msg, yyvsp[0].string);
      yyerror(msg);
    }
    
    yyval.list = clone(group);
    
  } else {
    
    /* we are not able to check the group we just return a dummy user */
    yyval.list = new_user(yyvsp[0].string);
    
  }
  
  if (yyvsp[0].string) { free(yyvsp[0].string); }
  
}
    break;

  case 12:
#line 222 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: dir_rule_list := dir_rule\n", yylineno); }
#endif
  yyval.list = yyvsp[0].list;
}
    break;

  case 13:
#line 228 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: dir_rule_list := dir_rule_list dir_rule\n", yylineno); }
#endif
  if (yyvsp[0].list != NULL) {
    yyvsp[-1].list = append(yyvsp[-1].list, clone(yyvsp[0].list));
  }
  yyval.list = yyvsp[-1].list;		  
}
    break;

  case 15:
#line 247 "parser.y"
    { init_readers(); }
    break;

  case 16:
#line 247 "parser.y"
    {

  if (apache_flag) {
    strncpy(location, yyvsp[-4].string, MAX_FILE_NAME_LENGTH);
    star = FALSE;
  }

#ifdef DEBUG
  if (debug_flag > 2) {
    printf("[debug-grammar] %i: dir_rule := [ DIR ] rule_list\n", yylineno);
  }
#endif
  
  if (subtree_flag) {
#ifdef HAVE_STRNLEN
    int subtree_len = strnlen(subtree, MAX_USER_SIZE);
    int dir_len     = strnlen(yyvsp[-4].string,      MAX_USER_SIZE);
#else
    int subtree_len = strlen(subtree);
    int dir_len     = strlen(yyvsp[-4].string);
#endif
    if (strncmp(yyvsp[-4].string, subtree, subtree_len) == 0) {
      if ((dir_len > subtree_len) &&
          (yyvsp[-4].string[subtree_len] != '/')) {
        fprintf(stderr, "Error: directory %s is not in the current subtree\n", yyvsp[-4].string);
        exit(EXIT_FAILURE);
      }    
    } else {
      fprintf(stderr, "Error: directory %s is not in the current subtree\n", yyvsp[-4].string);
      exit(EXIT_FAILURE);
    }
  }

  if (strcmp(yyvsp[-4].string,"/") == 0) {
    yyval.list = new_user(yyvsp[-4].string);
  } else {
    yyval.list = NULL;
  }

  if (apache_flag) {

    dir_node = malloc(sizeof(struct node));
    dir_node->name  = strdup(yyvsp[-4].string);
    dir_node->readers = additional_readers;
    dir_node->revoked = revoked_readers;
    dir_node->parent  = NULL;

    add_node("", dir_node);
  }

  if (yyvsp[-4].string) { free(yyvsp[-4].string); }

}
    break;

  case 17:
#line 302 "parser.y"
    { init_readers(); }
    break;

  case 18:
#line 302 "parser.y"
    {

  if (apache_flag) {
    strncpy(location, yyvsp[-4].string, MAX_FILE_NAME_LENGTH);
    star = FALSE;
  }
#ifdef DEBUG
  if (debug_flag > 2) {
    printf("[debug-grammar] %i: dir_rule := [ %s : %s ]\n", yylineno, yyvsp[-6].string, yyvsp[-4].string);
  }
#endif

  if (subtree_flag) {
#ifdef HAVE_STRNLEN
    int subtree_len = strnlen(subtree, MAX_USER_SIZE);
    int dir_len     = strnlen(yyvsp[-4].string,      MAX_USER_SIZE);
#else
    int subtree_len = strlen(subtree);
    int dir_len     = strlen(yyvsp[-4].string);
#endif
    if (strncmp(yyvsp[-4].string, subtree, subtree_len) == 0) {
      if ((dir_len > subtree_len) &&
          (yyvsp[-4].string[subtree_len] != '/')) {
        fprintf(stderr, "Error: directory %s is not in the current subtree\n", yyvsp[-4].string);
        exit(EXIT_FAILURE);
      }    
    } else {
      fprintf(stderr, "Error: directory %s is not in the current subtree\n", yyvsp[-4].string);
      exit(EXIT_FAILURE);
    }
  }

  if (strcmp(yyvsp[-4].string,"/") == 0) {
    yyval.list = new_user(yyvsp[-4].string);
  } else {
    yyval.list = NULL;
  }

  if (apache_flag) {

    dir_node = malloc(sizeof(struct node));
    dir_node->name  = strdup(yyvsp[-4].string);
    dir_node->readers = additional_readers;
    dir_node->revoked = revoked_readers;
    dir_node->parent  = NULL;

    add_node(yyvsp[-6].string, dir_node);
  }

  if (yyvsp[-6].string) { free(yyvsp[-6].string); }
  if (yyvsp[-4].string) { free(yyvsp[-4].string); }

}
    break;

  case 19:
#line 355 "parser.y"
    {
#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: dir_rule := [ %s ]\n", yylineno, yyvsp[-2].string); }
#endif
  if (yyvsp[-2].string) { free(yyvsp[-2].string); }
  yyval.list = NULL;
}
    break;

  case 20:
#line 362 "parser.y"
    {
  if (yyvsp[-4].string) { free(yyvsp[-4].string); }
  if (yyvsp[-2].string) { free(yyvsp[-2].string); }
  yyval.list = NULL;
}
    break;

  case 21:
#line 372 "parser.y"
    {

#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: rule : rule\n", yylineno); }
#endif

  yyval.list = yyvsp[0].list;

}
    break;

  case 22:
#line 381 "parser.y"
    {

#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: rule : rule rule_list\n", yylineno); }
#endif

  yyvsp[-1].list = append(yyvsp[-1].list, clone(yyvsp[0].list));
  yyval.list = yyvsp[-1].list;

}
    break;

  case 23:
#line 394 "parser.y"
    {            

#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: ID (%s) = ID (%s) \\n\n", yylineno, yyvsp[-3].list->name, yyvsp[-1].string); }
#endif

  cur = yyvsp[-3].list;
  while(cur) {

    if (!contains(additional_readers, cur)) {
      additional_readers = append(additional_readers, new_user(cur->name));
    }

    cur = cur->next;

  }

  if (strcmp(yyvsp[-1].string, "rw") == 0) {
    yyval.list = yyvsp[-3].list;
  } else {
    yyval.list = NULL;
  }

  if (yyvsp[-1].string) { free(yyvsp[-1].string); }

}
    break;

  case 24:
#line 420 "parser.y"
    {

#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: ID (%s) = \\n\n", yylineno, yyvsp[-2].list->name); }
#endif

  cur = yyvsp[-2].list;
  while(cur) {

    if (!contains(revoked_readers, cur)) {
      revoked_readers = append(revoked_readers, new_user(cur->name));
      cur = cur->next;
    }
  }

}
    break;

  case 25:
#line 436 "parser.y"
    {

#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: * = \\n\n", yylineno); }
#endif

  star = TRUE;

  if (strcmp(yyvsp[-1].string, "rw") == 0) {
    /* everybody is a writer */	     
  }

  if (!contains(additional_readers, anybody->name)) {
    additional_readers = append(additional_readers, clone(anybody));
  }

  if (yyvsp[-1].string) { free(yyvsp[-1].string); }

  yyval.list = NULL;

}
    break;

  case 26:
#line 458 "parser.y"
    {

#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: * = \\n\n", yylineno); }
#endif

  if (!contains(additional_readers, anybody)) {
    revoked_readers = append(revoked_readers, clone(anybody));
  }

  yyval.list = NULL;

}
    break;

  case 29:
#line 481 "parser.y"
    {

#ifdef HAVE_SQLITE_H

  struct trac_permission * new_permission;

#ifdef DEBUG
  if (debug_flag > 2) { printf("[debug-grammar] %i: TRAC %s = %s\n", yylineno, yyvsp[-3].string, yyvsp[-1].string); }
#endif

  /* append the new permission information to the trac permissions list */
  
  new_permission = malloc(sizeof(struct trac_permission));
  if (new_permission == NULL) {
    fprintf(stderr, "Error: out of memory\n");
    exit(EXIT_FAILURE);
  }

  new_permission->user = malloc(strlen(yyvsp[-1].string)+1);
  if (new_permission->user == NULL) {
    fprintf(stderr, "Error: out of memory\n");
    exit(EXIT_FAILURE);
  }
  strcpy(new_permission->user, yyvsp[-1].string);
  
  new_permission->permission = malloc(strlen(yyvsp[-3].string)+1);
  if (new_permission->permission == NULL) {
    fprintf(stderr, "Error: out of memory\n");
    exit(EXIT_FAILURE);
  }
  strcpy(new_permission->permission, yyvsp[-3].string);

  new_permission->next = trac;
  trac                 = new_permission;
  
  if (yyvsp[-3].string) { free(yyvsp[-3].string); }
  if (yyvsp[-1].string) { free(yyvsp[-1].string); }

#endif

}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 1550 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 525 "parser.y"


void yyerror (char const * message) {
  fprintf(stderr, "%s:%i: %s (%s)\n", filename, yylineno, message, yytext);
  exit(SYNTAX_ERROR);
}



